/* Batch Master -- module 7: Box, Reptchar, Skpline */

#include "batm.h"

void box(int argc, char *argv[])				/* Draw a box on the screen	*/
{
	int t, l, b, r, i;
	if (argc >= 6) {
		t = atoi(argv[2]);
		l = atoi(argv[3]);
		b = atoi(argv[4]);
		r = atoi(argv[5]);
		if (r <= l+1 || b <= t+1 || r > vid_cols || b > vid_rows)
			return;
		ireg.x.ax = 0x0600;						/* Clear the screen area	*/
		ireg.h.bh = (char) vid_attr;
		ireg.h.ch = t;
		ireg.h.cl = l;
		ireg.h.dh = b - 2;
		ireg.h.dl = r - 2;
		int86(0x10, &ireg, &oreg);
		if (argc == 8)				  				/* Set new colors				*/
			set_color(atoi(argv[6]), atoi(argv[7]));
		set_cursor(l-1,t-1);						/* Set the cursor				*/
		show_char(201);
		for (i = 0; i < r-l-1; i++)
			show_char(205);						/* Draw top row				*/
		show_char(187);
		for (i = t + 1; i <= b;  i++) {
			set_cursor(l-1,i-1);					/* Draw sides					*/
			show_char(186);
			set_cursor(r-1,i-1);
			show_char(186);
			}
		set_cursor(l-1,b-1);
		show_char(200);
		for (i = 0; i < r-l-1; i++)
			show_char(205);						/* Draw bottom row			*/
		show_char(188);
		}
}

void reptchar(int argc, char *argv[])
{
	int i;
	if (argc == 6)
		set_color(atoi(argv[4]), atoi(argv[5]));
	if (argc >= 4)
		{
		for (i = 0; i < atoi(argv[3]); i++)
			show_char(*argv[2]);
		show_line("",TRUE);
		}
}

void skpline(int argc, char *argv[])
{
	int count, i;
	if (argc >= 3)
		count = atoi(argv[2]);
	else
		count = 1;
	for (i = 0; i < count; i++) {
		if (curs_col == 0)
			curs_row++;
		else {
			show_char('\n');
			curs_row++;
			}
		}
	while (curs_row >= vid_rows) {
		scroll_up();
		curs_row--;
		}
	set_cursor(curs_col, curs_row);
}

